#ifndef LIBRS
#define LIBRS 0

/* 
   librs.h

   Data modify 1 Jul 2008
   (C) 2008. Kruchinin Aleksandr. http://vidikon.com
   May be used under the terms of the GNU Lesser General Public License (LGPL)

   Modify from libfec
   Copyright 2004, Phil Karn, KA9Q
   May be used under the terms of the GNU Lesser General Public License (LGPL)   
*/

typedef unsigned char data_t;

#define MODNN(x) modnn(rs,x)

#define MM (rs->mm)
#define NN (rs->nn)
#define ALPHA_TO (rs->alpha_to) 
#define INDEX_OF (rs->index_of)
#define GENPOLY (rs->genpoly)
#define NROOTS (rs->nroots)
#define FCR (rs->fcr)
#define PRIM (rs->prim)
#define IPRIM (rs->iprim)
#define PAD (rs->pad)
#define A0 (NN) 

/* Reed-Solomon codec control block */
struct rs {
  int mm;              /* Bits per symbol */
  int nn;              /* Symbols per block (= (1<<mm)-1) */
  data_t *alpha_to;     /* log lookup table */
  data_t *index_of;     /* Antilog lookup table */
  data_t *genpoly;      /* Generator polynomial */
  int nroots;     /* Number of generator roots = number of parity symbols */
  int fcr;        /* First consecutive root, index form */
  int prim;       /* Primitive element, index form */
  int iprim;      /* prim-th root of 1, index form */
  int pad;        /* Padding bytes in shortened block */
};

void free_rs_char(void *p);
void *init_rs_char(int symsize,int gfpoly,int fcr,int prim,
	int nroots,int pad);
int decode_rs_char(void *p, data_t *data, int *eras_pos, int no_eras);

#endif